﻿/// @file config.h
///
/// config.h
///
#ifndef _CONFIG_H_
#define _CONFIG_H_

#include "common.h"
#include <wx/wx.h>

#define MAX_RECENT_FILES 10

class Config
{
private:
	wxString ini_file;

	wxString mFilePath;
	bool     mMemoryCash;
	wxString mServerHost;
	long     mServerPort;
	int      mPrintDelay;
	int      mDensity;
	bool     mDataReverse;
	wxArrayString mRecentFiles;

public:
	Config();
	~Config();
	void SetFileName(const wxString &file);
	void Load(const wxString &file);
	void Load();
	void Save();

	// property
	void SetFilePath(const wxString &val) { mFilePath = val; }
	const wxString &GetFilePath() const { return mFilePath; }
	void SetMemoryCash(bool val) { mMemoryCash = val; }
	bool GetMemoryCash() const { return mMemoryCash; }
	void SetServerHost(const wxString &val) { mServerHost = val; }
	const wxString &GetServerHost() const { return mServerHost; }
	void SetServerPort(long val) { mServerPort = val; }
	long GetServerPort() const { return mServerPort; }
	void SetPrintDelay(int val) { mPrintDelay = val; }
	int GetPrintDelay() const { return mPrintDelay; }
	void SetDensity(int val) { mDensity = val; }
	int GetDensity() const { return mDensity; }
	void SetDataReverse(bool val) { mDataReverse = val; }
	bool GetDataReverse() const { return mDataReverse; }
	void AddRecentFile(const wxString &val);
	wxString &GetRecentFile();
	void GetRecentFiles(wxArrayString &vals);
};

extern Config gConfig;

#endif /* _CONFIG_H_ */
